{

This form is used when you want to add one single ROM to a folder.
I can't say I use this form very often, its often easier to just
drag and drop a single ROM in, but there is always a choice!

Uses the ROM class extensively.

Also saves the last directory that was used to add a ROM

}

unit fAddaRom;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TAddRomForm = class(TForm)
    TxtPath: TEdit;
    CmbEmu: TComboBox;
    OpenDialog: TOpenDialog;
    lblPath: TLabel;
    lblEmu: TLabel;
    BtnOK: TButton;
    BtnCancel: TButton;
    BtnDir: TButton;
    ChkScanZip: TCheckBox;
    procedure SpeedButton1Click(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BtnDirClick(Sender: TObject);

  private
    procedure Init();
  end;

implementation

uses fMain, uJUtilities, uRom, uROMList, Inifiles, JCLStrings, uEmuList, uQPConst;

{$R *.DFM}

{-----------------------------------------------------------------------------}

procedure TAddRomForm.BtnOKClick(Sender: TObject);
var
  NewROM : TQPROM;
begin

  if fileexists(TxtPath.text) AND (CmbEmu.text <> '') then
  begin

    With MainFrm do
    Begin

      If (ChkScanZip.Checked) then
      begin

        //the user wants to scan the zip file specified.

        //check that it IS a zip file.
        if (StrCompare('.zip', ExtractFileExt(TxtPath.Text)) <> 0) then
        begin
          MessageDlg(QP_ZIP_SCAN_NOT_ZIP, mtError, [mbOK], 0);
          modalresult := mrNone;
          exit;
        end;

        RomList.AddFromZip(TxtPath.Text, CmbEmu.Text, '', lmNone, False);

      end 
      else
      begin
        //just add the rom specified.
        ROMlist.Add(TQProm.create);

        NewROM := ROMlist.Last();

        NewROM.name := ChangeFileExt(ExtractFileName(TxtPath.text),'');
        NewROM.path := TxtPath.text;
        NewROM.emulator := CmbEmu.Text;

        ROMlist.SaveToFile();
      end;

      MainFrm.fillroms(MainFrm.GetSelectedTxt);

    end;

  end
  ELSE

  begin
    MessageDlg(QP_ENTER_ALL_DATA, mtWarning, [mbOK], 0);
    modalresult := mrNone;
  end;
  
end;

{-----------------------------------------------------------------------------}

procedure TAddRomForm.FormShow(Sender: TObject);
begin
  init();
end;

{-----------------------------------------------------------------------------}

procedure TAddRomForm.SpeedButton1Click(Sender: TObject);
var
  Ini : TMemIniFile;
begin

  Ini := TMemIniFile.Create(MainFrm.Settings.SettingsFile);
  Try

    if Ini.ValueExists('Scan','LastDir') then
      OpenDialog.InitialDir := Ini.ReadString('Scan','LastAddDir','')
    else
      OpenDialog.InitialDir := '';

    opendialog.filename := '';
    opendialog.title := QP_SELECT_ROM;
    opendialog.filter := 'Zip Files (*.zip)|*.zip|All Files|*.*';

    if opendialog.execute then
      if OpenDialog.FileName <> '' then
      begin
        TxtPath.text := opendialog.filename;
        Ini.WriteString('Scan','LastAddDir', extractfilepath(OpenDialog.Filename));
        if MainFrm.Settings.AllowWrite then
          Ini.UpdateFile;
      end;

  finally
    FreeAndNil(Ini);
  end;

end;


{-----------------------------------------------------------------------------}
{                              Private Routines                               }
{-----------------------------------------------------------------------------}

procedure TAddRomForm.Init();
begin
  TxtPath.text := '';
  MainFrm.EmuList.EmusToStrings(CmbEmu.Items, cfAllEmus);
  CmbEmu.itemindex := 0;
end;                            

{-----------------------------------------------------------------------------}

procedure TAddRomForm.BtnDirClick(Sender: TObject);
var
  Ini : TMemIniFile;
begin

  Ini := TMemIniFile.Create(MainFrm.Settings.SettingsFile);
  Try

    if Ini.ValueExists('Scan','LastDir') then
      OpenDialog.InitialDir := Ini.ReadString('Scan','LastAddDir','')
    else
      OpenDialog.InitialDir := '';

    opendialog.filename := '';
    opendialog.title := QP_SELECT_ROM;
    opendialog.filter := 'Zip Files (*.zip)|*.zip|All Files|*.*';

    if opendialog.execute then
      if OpenDialog.FileName <> '' then
      begin
        TxtPath.text := opendialog.filename;
        Ini.WriteString('Scan','LastAddDir', extractfilepath(OpenDialog.Filename));
        if MainFrm.Settings.AllowWrite then
          Ini.UpdateFile;
      end;

  finally
    FreeAndNil(Ini);
  end;

end;

end.
