{
  This is the editor for the EFind Data files.  Can create new files,
  delete files, or add/edit/delete an entry in the file.  It 'automatically'
  saves all changes when you exit the groupbox containing the text fields.
  Although this may cause problems if you balls up when editing a record,
  as it will be automatically saved - and there is nothign you can do about
  it!  Might implement a 'Reset' button to fix the balls up..
}

unit fEditEmuFind;
                                                         
interface

uses
  Windows, SysUtils, Classes, Controls, Forms, StdCtrls, Dialogs;

type
  TFrmEFindEdit = class(TForm)
    LstEmus: TListBox;
    BtnClose: TButton;
    BtnAdd: TButton;
    BtnDelete: TButton;
    GrpRecord: TGroupBox;
    Label1: TLabel;
    ChkZip: TCheckBox;
    ChkMame: TCheckBox;
    ChkShortRom: TCheckBox;
    ChkShortExe: TCheckBox;
    ChkVerify: TCheckBox;
    ChkScrSvr: TCheckBox;
    ChkWinKey: TCheckBox;
    TxtName: TEdit;
    TxtEXE: TEdit;
    TxtConfig: TEdit;
    CmbSystem: TComboBox;
    BtnNewINI: TButton;
    LstFiles: TListBox;
    BtnDelIni: TButton;
    ChkSpeechMarks: TCheckBox;
    TxtHomePage: TEdit;
    Label2: TLabel;
    chkCmdLine: TCheckBox;
    ChkShellEx: TCheckBox;
    ChkMameIncPath: TCheckBox;
    ChkOnlyROMName: TCheckBox;
    ChkIncROMExt: TCheckBox;
    TxtParam: TEdit;
    ChkParamBefore: TCheckBox;
    ChkWin32: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure BtnDeleteClick(Sender: TObject);
    procedure BtnAddClick(Sender: TObject);
    procedure BtnNewINIClick(Sender: TObject);
    procedure LstFilesClick(Sender: TObject);
    procedure LstEmusClick(Sender: TObject);
    procedure GrpRecordExit(Sender: TObject);
    procedure BtnDelIniClick(Sender: TObject);
  private
    { Private declarations }
    IniFile, CurName, OldName : String;
    procedure DataLoad(Rec : String);
    procedure RecordSetup(OnOff, Clear: Boolean);
  public
    { Public declarations }
  end;

implementation

uses fMain, uJUtilities, FindFile, IniFiles, uQPConst;

{$R *.dfm}

Procedure TFrmEFindEdit.RecordSetup(OnOff, Clear : Boolean);
Var
  I : Integer;
Begin

  //Code to disable or enable all the controls in the record box
  For I := 0 to GrpRecord.ControlCount-1 do
    (GrpRecord.Controls[i] as TControl).Enabled := OnOff;

  //Clear Text Code
  If Clear then
  For I := 0 to GrpRecord.ControlCount-1 do
  Begin

    If GrpRecord.Controls[i] is TEdit then
    Begin
      (GrpRecord.Controls[i] as TEdit).Text :='';
       Continue;
    end;

    If GrpRecord.Controls[i] is TCheckBox then
    Begin
      (GrpRecord.Controls[i] as TCheckBox).Checked := False;
      Continue;
    end;

    If GrpRecord.Controls[i] is TComboBox then
    Begin
      (GrpRecord.Controls[i] as TComboBox).ItemIndex := -1;
      Continue;
    end;

  End; //end of FOR loop

End;

procedure TFrmEFindEdit.FormShow(Sender: TObject);
Var
  Find : ThhFindFile;
  I : Integer;
begin

  RecordSetup(False, True);
  Find := ThhFindFile.create(Self);
  Try

    Find.Directory := MainFrm.Settings.QPDirectory + 'Efind\';
    find.Filter := '*.ini';
    Find.Execute;

    LstFiles.Items.Clear;
    LstEmus.Items.Clear;
    For I := 0 to Find.TotalFile-1 do
      LstFiles.Items.Add(ChangeFileExt(ExtractFileName(Find.Files[i]),''));

  Finally
    FreeAndNil(Find);
  end;

  CmbSystem.Items.LoadFromFile(MainFrm.Settings.SettingsDir + 'systems.dat');

end;         

procedure TFrmEFindEdit.BtnDeleteClick(Sender: TObject);
Var
  Ini : TMemIniFile;
begin

  If LstEmus.ItemIndex = -1 then Exit;

  if MessageDlg(QP_DELETE_REC_VERIFY,
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  Begin

    Ini := TMemIniFile.Create(IniFile);
    Try

      If Ini.SectionExists(LstEmus.Items.Strings[LstEmus.itemIndex]) Then
        Ini.EraseSection(LstEmus.Items.Strings[LstEmus.itemIndex]);

      if MainFrm.Settings.AllowWrite then
        Ini.UpdateFile;

      //reload the listing
      LstEmus.Clear;
      Ini.ReadSections(LstEmus.Items);

    Finally
      FreeAndNil(Ini);
    end;

  End;  //end of prompt IF

end;

procedure TFrmEFindEdit.BtnAddClick(Sender: TObject);
begin
  If LstFiles.ItemIndex = -1 then
  Begin
    MessageDlg(QP_FILE_NOT_SELECTED, mtError, [mbOK], 0);
    Exit;
  End;
  LstEmus.ItemIndex := -1;
  OldName := '';
  RecordSetup(True, True);
  TxtName.SetFocus;
end;

procedure TFrmEFindEdit.BtnNewINIClick(Sender: TObject);
Var
  Ini : TMemIniFile;
  Fini : String;
begin

  FIni := MainFrm.Settings.QPDirectory + 'Efind\' + InputBox(QP_FILE_ENTER_NAME, QP_FILE_ENTER_NAME_NO_EXT, '') + '.ini';
  If Fini <> '' then
  Begin
    Ini := TMemIniFile.Create(Fini);
    Try
      if MainFrm.Settings.AllowWrite then
        Ini.UpdateFile;
    Finally
      FreeAndNil(Ini);
    end;

    FormShow(BtnNewIni);
  End;
end;

procedure TFrmEFindEdit.LstFilesClick(Sender: TObject);
Var
  Ini : TMemIniFile;
begin
  IniFile := MainFrm.Settings.QPDirectory + 'Efind\' + LstFiles.Items.Strings[LstFiles.ItemIndex] + '.ini';

  Ini := TMemIniFile.Create(Inifile);
  Try
    Ini.ReadSections(LstEmus.Items);
  Finally
    FreeAndNil(Ini);
  end;
  
  RecordSetup(false, true);
end;

procedure TFrmEFindEdit.DataLoad(Rec: String);
Var
  Ini : TMemIniFile;
begin
  Ini := TMemIniFile.Create(IniFile);
  Try

    RecordSetup(true, true);
    TxtName.Text := Rec;
    OldName := TxtName.Text;

    TxtExe.Text := Ini.ReadString(Rec, 'EXE Name', '');
    TxtConfig.Text := Ini.ReadString(Rec, 'Config Name', '');
    CmbSystem.ItemIndex := CmbSystem.Items.IndexOf(Ini.ReadString(Rec, 'System', ''));
    TxtHomePage.Text := Ini.ReadString(Rec, 'HomePage', '');
    TxtParam.Text := Ini.ReadString(Rec, 'param', '');
    ChkParamBefore.Checked := Ini.ReadBool(Rec, 'parambefore', false);
    ChkWin32.Checked := Ini.ReadBool(Rec, 'isWin32', True);
    ChkCmdLine.Checked := Ini.ReadBool(Rec, 'CmdLine', true);
    ChkShellEx.Checked := Ini.ReadBool(Rec, 'ShellEx', false);
    ChkZip.Checked := Ini.ReadBool(Rec, 'Zip', false);
    ChkVerify.Checked := Ini.ReadBool(Rec, 'Verify', false);
    ChkMame.Checked := Ini.ReadBool(Rec, 'Mame', false);
    ChkMameIncPath.Checked := Ini.ReadBool(Rec, 'MameIncPath', false);
    ChkOnlyROMName.Checked := Ini.ReadBool(Rec, 'OnlyROMName', false);
    ChkIncROMExt.Checked := Ini.ReadBool(Rec, 'IncROMExt', false);
    chkSpeechMarks.Checked := Ini.ReadBool(Rec, 'UseSpeechMarks',false);
    chkShortROM.Checked := Ini.ReadBool(Rec, 'ShortRom', false);
    ChkShortExe.Checked := Ini.ReadBool(Rec, 'ShortExe', false);
    ChkWinKey.Checked := Ini.ReadBool(Rec, 'DisWinKey', false);
    ChkScrSvr.Checked := Ini.ReadBool(Rec, 'DisScrSvr', false);

  Finally
    FreeAndNil(Ini);
  end;
end;

procedure TFrmEFindEdit.LstEmusClick(Sender: TObject);
begin
  If LstEmus.ItemIndex = -1 then
    exit;
  DataLoad(LstEmus.Items.Strings[LstEmus.ItemIndex]);
end;

procedure TFrmEFindEdit.GrpRecordExit(Sender: TObject);
Var
  Ini : TMemIniFile;
  Reload : Boolean;
begin

  //first thing to do is to validate the data
  If TxtName.Text = '' then
  Begin
    if MessageDlg(QP_EDITEFIND_BAD_NAME,
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    TxtName.SetFocus;
    Exit;
  End;
  If TxtExe.Text = '' then
  Begin
    if MessageDlg(QP_EDITEFIND_BAD_EXE,
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      Txtexe.SetFocus;
    Exit;
  End;
  if CmbSystem.Text = '' then
  Begin
    if MessageDlg(QP_EDITEFIND_BAD_SYS,
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      CmbSystem.SetFocus;
    Exit;
  End;

  CurName := TxtName.Text;
  Reload := False;

  Ini := TMemIniFile.Create(IniFile);
  Try

    If (OldName <> '') AND (OldName <> CurName) then
    Begin
      Ini.EraseSection(OldName);
      Reload := True;
    end;

    If (OldName = '') then
      Reload := True;

    Ini.WriteString(CurName, 'Exe Name',TxtEXE.Text);
    Ini.WriteString(CurName, 'Config Name', TxtConfig.Text);
    Ini.WriteString(CurName, 'System', CmbSystem.Text);
    Ini.WriteString(CurName, 'HomePage', TxtHomePage.Text);
    Ini.WriteString(CurName, 'param', TxtParam.Text);
    Ini.WriteBool(CurName, 'parambefore', ChkParamBefore.Checked);
    Ini.WriteBool(CurName, 'isWin32', ChkWin32.Checked);
    Ini.WriteBool(CurName, 'CmdLine', ChkCmdLine.Checked);
    Ini.WriteBool(CurName, 'ShellEx', ChkShellEx.Checked);
    Ini.WriteBool(CurName, 'Zip', ChkZip.Checked);
    Ini.WriteBool(CurName, 'Verify', ChkVerify.Checked);
    Ini.WriteBool(CurName, 'Mame', ChkMame.Checked);
    Ini.WriteBool(CurName, 'MameIncPath', ChkMameIncPath.Checked);
    Ini.WriteBool(CurName, 'OnlyROMName', ChkOnlyROMName.Checked);
    Ini.WriteBool(CurName, 'IncROMExt', ChkIncROMExt.Checked);
    Ini.WriteBool(CurName, 'UseSpeechMarks', ChkSpeechMarks.Checked);
    Ini.WriteBool(CurName, 'ShortRom', chkShortROM.Checked);
    Ini.WriteBool(CurName, 'ShortExe', ChkShortExe.Checked);
    Ini.WriteBool(CurName, 'DisWinKey', ChkWinKey.Checked);
    Ini.WriteBool(CurName, 'DisScrSvr', ChkScrSvr.Checked);

    if MainFrm.Settings.AllowWrite then
      Ini.UpdateFile;

    If Reload then
    Begin
      LstEmus.Clear;
      Ini.ReadSections(LstEmus.Items);
    end;
    
  Finally
    FreeAndNil(Ini);
  end;

end;

procedure TFrmEFindEdit.BtnDelIniClick(Sender: TObject);
var
  DelFile : String;
begin
  If LstFiles.ItemIndex = -1 then Exit;

  DelFile := MainFrm.Settings.QPDirectory + 'Efind\' + LstFiles.Items.Strings[LstFiles.ItemIndex] + '.ini';

  if MessageDlg(QP_FILE_VERIFY_DELETE,
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  Begin
    If FileExists(DelFile) then
      DeleteFile(DelFile);

    FormShow(BtnDelIni);
  End;
end;

end.
