{
  Emu-Finder Form
  This form contains the code behind the emu-finder.  has 2 VTs.
  Essentially the user provides a directory and choice of data files
  Load these datafiles into an array
  perform search of users directory.
  match any filenames with the names in our array
  add these results to a temporary record
  display the results in a VT, and allow user to check appropriate ones
  save/or dont save!
}

unit fEmuFind;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls,Contnrs,
  VirtualTrees, FindFile, JvBaseDlg, JvBrowseFolder,
  JvCombobox, JvDriveCtrls, JvComponent, JvExStdCtrls, uEmu;

type
 
  //record for the structure of an Efind INI record.
  TQPEmuFindData = class(TObject)
  public
    name,
    exe,
    cfg,
    system,
    HomePage : String;
    isWin32,
    CmdLine,
    ShellEx,
    mame,
    MameIncPath,
    OnlyROMName,
    IncROMExt,
    UseSpeechMarks,
    ShortExe,
    ShortRom,
    zip,
    Verify,
    DisScrSvr,
    DisWinKey : Boolean;
    //2 new entries, currently only really needed for ePSXe
    Param : String; 
    ParamBefore : Boolean;

    Procedure CopyToEmu(Emu : TQPEmu; EFileName : TFileName);
    function IsMatch(FileName : TFileName):Boolean;
  end;

  TEmuFinder = class(TForm)
    FindEmu: ThhFindFile;
    PCWizard: TPageControl;
    TabIntro: TTabSheet;
    TabResults: TTabSheet;
    Label1: TLabel;
    RadOverwrite: TRadioButton;
    RadAppend: TRadioButton;
    BtnUpdate: TButton;
    BtnNoSave: TButton;
    BtnExit: TButton;
    GrpDir: TGroupBox;
    RadSetDir: TRadioButton;
    PathTxt: TEdit;
    BtnDir: TSpeedButton;
    RadAllDrive: TRadioButton;
    DriveBox: TJvDriveCombo;
    GrpDats: TGroupBox;
    RadAllDats: TRadioButton;
    RadSelDats: TRadioButton;
    GrpStart: TGroupBox;
    btnStart: TButton;
    VTEFind: TVirtualStringTree;
    VTdats: TVirtualStringTree;
    lblFound: TLabel;
    jvBrowse: TJvBrowseForFolderDialog;
    procedure FormShow(Sender: TObject);
    procedure BtnDirClick(Sender: TObject);
    procedure RadAllDriveClick(Sender: TObject);
    procedure RadSetDirClick(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure RadAllDatsClick(Sender: TObject);
    procedure RadSelDatsClick(Sender: TObject);
    procedure BtnUpdateClick(Sender: TObject);
    procedure VTEFindGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure VTEFindCompareNodes(Sender: TBaseVirtualTree; Node1,
      Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
    procedure VTEFindHeaderClick(Sender: TVTHeader; Column: TColumnIndex;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure VTdatsInitNode(Sender: TBaseVirtualTree; ParentNode,
      Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
    procedure VTdatsGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure FormCreate(Sender: TObject);
    procedure VTEFindEditing(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; var Allowed: Boolean);
    procedure VTEFindNewText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; NewText: WideString);
    procedure VTEFindFreeNode(Sender: TBaseVirtualTree;
      Node: PVirtualNode);
    procedure VTEFindExit(Sender: TObject);

  private
    { Private declarations }
    DatFileList : TStringList;
    EFindData : TObjectList;
    ResultList : TObjectList;
    Function FindDats(): boolean;
    procedure LoadDats;
    
  end;

implementation

uses fMain, uJUtilities, JCLStrings, IniFiles, uJFile, uJVirtualTree, uQPConst;

{$R *.DFM}
{$WARN SYMBOL_PLATFORM OFF}

{-----------------------------------------------------------------------------}
{TQPEmuFindData}

Procedure TQPEmuFindData.CopyToEmu(Emu : TQPEmu; EFileName : TFileName);
begin
  //If its an arcade emulator then stick a DOS or WIN on the end
  //of the name - helps with the way MAME is changing names every
  //Two minutes!
  if StrCompare(self.system, 'arcade')=0 then
  begin
    if ExeTypeToString(EFileName) = QP_EXE_WIN32 then
      Emu.name := Self.name + ' ' + QP_EXE_WIN32;
    if ExeTypeToString(EFileName) = QP_EXE_DOS then
      Emu.name := Self.name + ' ' + QP_EXE_DOS;

  end
  else
    Emu.name := Self.name;

  Emu.path := lowercase(EFileName);

  Emu.WorkingDir := ExtractFilePath(EFileName);

  Emu.system := Self.system;

  Emu.cfg := '';
  If FileExists(extractfilepath(EFileName) + Self.cfg + '.cfg') then
    Emu.cfg := extractfilepath(EFileName) + Self.cfg + '.cfg'
  Else
    If FileExists(extractfilepath(EFileName) + Self.cfg + '.ini') then
      Emu.cfg := extractfilepath(EFileName) + Self.cfg + '.ini';

  Emu.HomePage := Self.HomePage;
  Emu.CmdLine := Self.CmdLine;
  Emu.ShellEx := Self.ShellEx;
  Emu.Mame := Self.Mame;
  Emu.MameIncPath := Self.MameIncPath;
  Emu.OnlyROMName := Self.OnlyROMName;
  Emu.IncROMExt := Self.IncROMExt;
  Emu.UseSpeechMarks := Self.UseSpeechMarks;
  Emu.ShortExe := Self.ShortExe;
  Emu.ShortRom := Self.ShortRom;
  Emu.zip := Self.zip;
  Emu.Verify := Self.Verify;
  Emu.DisScrSvr := Self.DisScrSvr;
  Emu.DisWinKey := Self.DisWinKey;
  Emu.Parameters := Self.Param;
  Emu.ParamBefore := Self.ParamBefore;
end;

{-----------------------------------------------------------------------------}

function TQPEmuFindData.IsMatch(FileName : TFileName):Boolean;
begin
  // filenames must match, also the type of EXE must match.
  if ( StrCompare(extractfilename(FileName), self.exe)=0 ) then
  begin
    if (ExeTypeToString(FileName) = QP_EXE_WIN32) and (Self.isWin32) then
      Result := True
    else if (ExeTypeToString(FileName) = QP_EXE_DOS) and (not Self.isWin32) then
      Result := True
    else
      Result := False;
  end
  else
    Result := False;

end;


{-----------------------------------------------------------------------------}
{TEmuFinder}
{-----------------------------------------------------------------------------}

procedure TEmuFinder.FormCreate(Sender: TObject);
begin
  VTEfind.NodeDataSize := SizeOf(Pointer);
  ResultList := TObjectList.Create(True);
  DatFileList := TStringList.Create;
  EFindData := TObjectList.Create(True);
end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.FormShow(Sender: TObject);
begin
  FindDats;
  PCWizard.ActivePage := TabIntro;
end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.FormClose(Sender: TObject; var Action: TCloseAction);
begin

  if DatFileList <> nil then
    FreeAndNil(DatFileList);

  ResultList.Clear;
  FreeAndNil(ResultList);

  FreeAndNil(EFindData);
  
  action := caFree;
end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.BtnDirClick(Sender: TObject);
var
  Ini : TMemInifile;
begin

  Ini := TMemInifile.create(MainFrm.Settings.SettingsFile);
  try

    if Ini.ValueExists('eFind','LastDir') then
      JvBrowse.Directory := Ini.ReadString('eFind','LastDir','');

    if JvBrowse.execute then
      PathTxt.text := JvBrowse.Directory;
      
    if JvBrowse.Directory <> '' then
    begin
      Ini.WriteString('eFind','LastDir', JvBrowse.Directory);
      if MainFrm.Settings.AllowWrite then
        ini.UpdateFile;
    end;

  finally
    FreeAndNil(ini);
  end;
end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.RadAllDriveClick(Sender: TObject);
begin
  pathTxt.enabled := false;
  BtnDir.enabled := false;
  DriveBox.enabled := true;
end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.RadSetDirClick(Sender: TObject);
begin
  pathTxt.enabled := true;
  BtnDir.enabled := true;
  DriveBox.enabled := false;
end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.btnStartClick(Sender: TObject);
var
  oldstyle : TCursor;
  i, c : integer;
  NewResult : TQPEmu;
  Node : PVirtualNode;
  NewIndex : Integer;
begin

  //Firstly change the cursor to the hourglass.
  oldstyle := screen.cursor;
  screen.cursor := crHourGlass;
  Try
    loadDats;

  //now figure out whether to scan the entire drive or a directory.
  if RadAllDrive.checked = true then
    FindEmu.Directory := drivebox.Drive + ':\';
  if RadSetDir.checked = true then
  begin
    if Pathtxt.text <> '' then
      FindEmu.directory := PathTxt.text
    else
    begin
      MessageDlg(QP_DIRECTORY_NOT_SPECIFIED, mtError, [mbOK], 0);
      screen.cursor := oldstyle;
      exit;
    end;
  end;

  //start the search
  FindEmu.Execute;

  If FindEmu.TotalFile > 0 then
    ResultList.Clear;

  for i := 0 to FindEmu.TotalFile-1 do
  begin  //start of iteration through find results

    for c := 0 to EFindData.Count-1 do
    begin //start of iteration through the emu data files

      if TQPEmuFindData(EFindData[c]).IsMatch(FindEmu.Files[i]) then
      begin
        NewIndex := ResultList.Add(TQPEmu.Create);
	      NewResult := TQPEmu(ResultList.items[NewIndex]);
        TQPEmuFindData(EFindData[c]).CopyToEmu(NewResult, FindEmu.Files[i]);
        Break;
       end; //end of WITH block

    end; // end of iteration through emu data files

  end; //end of iteration through find results

  //we dont need the emuDats array anymore so clear it
  EFindData.Clear;

  //if resultslist.Items.Count > 0 then
  If ResultList.Count > 0 then
  begin
    btnupdate.Enabled := true;
    VTEfind.RootNodeCount := ResultList.Count;

    Node := VTEfind.GetFirst;
    while Node <> nil do
    begin
      SetObject(VTEfind, Node, ResultList.Items[Node.Index]);
      VTEfind.CheckType[Node] := ctCheckBox;
      VTEfind.CheckState[Node] := csCheckedNormal;
      Node := Node.NextSibling;
    end;

    lblFound.Caption := IntToStr(ResultList.Count);
  end;

  Finally
    screen.cursor := oldstyle;
  end;

  PCWizard.ActivePageIndex := 1;
  
end;
{-----------------------------------------------------------------------------}

//Procedure to find all available Dat Files for the EmuFinder.
Function TemuFinder.FindDats(): boolean;
var
  Datfind : ThhFindFile;
  i : integer;
  error : boolean;
begin
  //initialise the datFound array to 0
  VTdats.Clear;
  
  error := false;

  DatFind := ThhFindFile.create(self);
  try

    if directoryexists(MainFrm.Settings.QPDirectory + 'Efind\') then
    begin
      datfind.Directory := MainFrm.Settings.QPDirectory + 'EFind\';
      datFind.Filter := '*.ini';
      datfind.execute;

      if datfind.TotalFile > 0 then
      begin

        for i := 0 to datfind.totalfile-1 do
          DatFileList.Add(datfind.files[i]);

        VTdats.RootNodeCount := DatFileList.Count;
        
      end //end of IF statement

      else
      begin
        MessageDlg(QP_EFIND_NO_FILES, mtError, [mbOK], 0);
        error := true;
      end;

    end

    else
    begin
      MessageDlg(QP_EFIND_NO_DIR, mtError, [mbOK], 0);
      error := true;
    end;

  finally
    FreeAndNil(datfind);
  end;
  result := error;
end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.LoadDats();
var
  Ini : TMemIniFile;
  Sections : TStringList;
  i : integer;
  aNode : PVirtualNode;
  CurData : TQPEmuFindData;
begin
  //Find out whether to use all Dat Files or not.

  aNode := VTdats.GetFirst;
  while aNode <> nil do
  begin

    //if the node is checked OR we are using all data files load the file.
    if (radAllDats.checked = true) OR (VTDats.CheckState[aNode] = csCheckedNormal) then
    begin
      Sections := nil;
      Ini := TMemInifile.Create(DatFileList[aNode.Index]);
      try
        Sections := TStringList.Create;
        Ini.ReadSections(Sections);

        for i := 0 to Sections.Count-1 do
        begin
          EFindData.Add(TQPEmuFindData.Create);
          CurData := TQPEmuFindData(EFindData.Last);
          CurData.name := Sections.strings[i];
          CurData.exe := Ini.ReadString(Sections.strings[i], 'EXE Name', '');
          CurData.cfg := Ini.ReadString(Sections.strings[i], 'Config Name', '');
          CurData.system := Ini.ReadString(Sections.strings[i], 'System', '');
          CurData.HomePage := Ini.ReadString(Sections.Strings[i], 'HomePage', '');
          CurData.isWin32 := Ini.ReadBool(Sections.Strings[i], 'isWin32', true);
          CurData.CmdLine := Ini.ReadBool(Sections.Strings[i], 'CmdLine', true);
          CurData.ShellEx := Ini.ReadBool(Sections.strings[i], 'ShellEx', false);
          CurData.zip := Ini.ReadBool(Sections.strings[i], 'Zip', False);
          CurData.mame := Ini.ReadBool(Sections.strings[i], 'Mame', False);
          CurData.MameIncPath := Ini.ReadBool(Sections.strings[i], 'MameIncPath', false);
          CurData.OnlyROMName := Ini.ReadBool(Sections.strings[i], 'OnlyROMName', false);
          CurData.IncROMExt := Ini.ReadBool(Sections.strings[i], 'IncROMExt', false);
          CurData.UseSpeechMarks := Ini.ReadBool(Sections.strings[i], 'UseSpeechMarks', False);
          CurData.ShortExe := Ini.ReadBool(Sections.strings[i], 'ShortExe', False);
          CurData.ShortRom := Ini.ReadBool(Sections.strings[i], 'ShortRom', False);
          CurData.DisScrSvr := Ini.ReadBool(Sections.strings[i], 'DisScrSvr', False);
          CurData.DisWinKey := Ini.ReadBool(Sections.strings[i], 'DisWinKey', False);
          CurData.Verify := Ini.ReadBool(Sections.strings[i], 'Verify', False);
          CurData.Param := Ini.ReadString(Sections.strings[i], 'Param', '');
          CurData.ParamBefore := Ini.ReadBool(Sections.strings[i], 'ParamBefore', false);
        end;

      finally
        FreeAndNil(Ini);
        FreeAndNil(Sections);
      end;

    end;

    //get the next node
    aNode := VTdats.GetNext(aNode);
  end;

  //we have now finished with the DATS array and treelist so clear it
  VTdats.Clear;
  FreeAndNil(DatFileList);

end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.RadAllDatsClick(Sender: TObject);
begin
  Vtdats.enabled := false;
end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.RadSelDatsClick(Sender: TObject);
begin
  VTdats.enabled := true;
end;

{-----------------------------------------------------------------------------}

//This procedure adds the Search results to the emulator Array.
procedure TEmuFinder.BtnUpdateClick(Sender: TObject);
var
  oldstyle : TCursor;
  e, n, NewIndex : integer;
  exists, dup : boolean;
  tempName : string;
  aNode : PVirtualNode;
  CurResult : TQPEmu;
begin

  //firstly set the cursor to the hourglass - this cud be a while!
  oldstyle := screen.cursor;
  screen.cursor := crHourGlass;
  Try

    // determine which method the user wants to use to SAVE results
    With MainFrm do
    Begin
      // If the user wishes to overwrite the existing array then
      // clear the emulator list.

      if radOverWrite.checked = true then
      begin
        EmuList.Clear;
      end;

      //If the user wishes to add the results to the array then prepare this
      if radAppend.checked = true then
      begin
        EmuList.LoadFromFile;
      end;

      // start iterating through all the nodes in the treeview
      aNode := VTefind.GetFirst;
      while aNode <> nil do
      Begin
  
        // if the node is checked then we will add it - unchecked we dont.
        if VTefind.CheckState[aNode] <> csUncheckedNormal then
        Begin
          CurResult := TQPEmu(GetObject(VTEfind, aNode));

          TempName := CurResult.name;
          exists := false;
          n := 0;

          //Check if the emulator already exists
          for e := 0 to EmuList.Count-1 do
          begin

            if StrCompare(CurResult.path, EmuList.Items[e].path)=0 then
            begin
              exists := true;
              break;
            end;

            repeat
              dup := false;
              if strCompare(CurResult.name, EmuList.Items[e].name)=0 then
              begin
                inc(n);
                CurResult.name := TempName + ' ' + IntToStr(n);
                dup := true;
              end;
            until dup = false;

          end;  //end of FOR loop through emulators

          if (exists = false) then
          begin
            NewIndex := Emulist.Add(TQPEmu.Create);
            Emulist.Items[NewIndex].Assign(CurResult);
          end;  //end of IF block

        tempName := '';

        End;

        //get the next node
        aNode := VTefind.GetNext(aNode);

      End; // end of WHILE loop

      EmuList.SaveToFile;

      ResultList.Clear;
    end;

   // end;  //end of WITH block
    
  //set the cursor back to normal.
  Finally
    screen.cursor := OldStyle;
    modalresult := MrOk;
  end;
  
end;

{-----------------------------------------------------------------------------}

{-------------------- code for VTefind -------------------------------}

{-----------------------------------------------------------------------------}

procedure TEmuFinder.VTEFindGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var
  data : TQPEmu;
begin
  data := TQPEmu(GetObject(Sender, Node));

  Case Column of
    0: CellText := Data.name;
    1: CellText := Data.path;
    2: CellText := Data.system;
  end;

end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.VTEFindCompareNodes(Sender: TBaseVirtualTree; Node1,
  Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
var
  data1, data2 : TQPEmu;
begin

  Data1 := TQPEmu(GetObject(Sender, Node1));
  Data2 := TQPEmu(GetObject(Sender, Node2));

  if (Data1 = nil) or (Data2 = nil) then
    exit;
    
  case Column of
    0:Result := CompareText(Data1.name, Data2.name);
    1:Result := CompareText(Data1.path, Data2.path);
    2:Result := CompareText(Data1.system, Data2.system);
  end;
end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.VTEFindHeaderClick(Sender: TVTHeader;
  Column: TColumnIndex; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
if Button = mbLeft then
  begin
    with Sender, Treeview do
    begin
      if SortColumn > NoColumn then
        Columns[SortColumn].Options := Columns[SortColumn].Options + [coParentColor];

        if (SortColumn = NoColumn) or (SortColumn <> Column) then
        begin
          SortColumn := Column;
          SortDirection := sdAscending;
        end
        else
          if SortDirection = sdAscending then
            SortDirection := sdDescending
          else
            SortDirection := sdAscending;

        Columns[SortColumn].Color := $F7F7F7;
        SortTree(SortColumn, SortDirection, False);
    end;
  end;
end;

procedure TEmuFinder.VTEFindEditing(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; var Allowed: Boolean);
begin
  Allowed := (Column = 0)
end;

procedure TEmuFinder.VTEFindFreeNode(Sender: TBaseVirtualTree;
  Node: PVirtualNode);
begin
  SetObject(Sender, Node, nil);
end;

procedure TEmuFinder.VTEFindNewText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; NewText: WideString);
begin
  If (Node <> nil) and (NewText <> '') then
    TQPEmu(GetObject(sender, node)).name := NewText;
end;

{----------------------- end of code for VTefind -------------------------}

{ ----------------------  Code for VTdats --------------------------------}

procedure TEmuFinder.VTdatsInitNode(Sender: TBaseVirtualTree; ParentNode,
  Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
begin
  VTDats.CheckType[Node] := ctCheckBox;
  VTDats.CheckState[Node] := csUnCheckedNormal;
end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.VTdatsGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
begin
  if node <> nil then
    CellText := ExtractFileName(ChangeFileExt(DatFileList[Node.Index], ''));
end;

{-----------------------------------------------------------------------------}

procedure TEmuFinder.VTEFindExit(Sender: TObject);
begin
  if VTEfind.IsEditing then
    VTEfind.EndEditNode;
end;

end.
