{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
{$WARN SYMBOL_DEPRECATED ON}
{$WARN SYMBOL_LIBRARY ON}
{$WARN SYMBOL_PLATFORM ON}
{$WARN UNIT_LIBRARY ON}
{$WARN UNIT_PLATFORM ON}
{$WARN UNIT_DEPRECATED ON}
{$WARN HRESULT_COMPAT ON}
{$WARN HIDING_MEMBER ON}
{$WARN HIDDEN_VIRTUAL ON}
{$WARN GARBAGE ON}
{$WARN BOUNDS_ERROR ON}
{$WARN ZERO_NIL_COMPAT ON}
{$WARN STRING_CONST_TRUNCED ON}
unit fZip;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons,
  JvBaseDlg, JvBrowseFolder, JvComponent;

type
  TFrmZip = class(TForm)
    PageZip: TPageControl;
    ShtUnzip: TTabSheet;
    shtZip: TTabSheet;
    TxtInput: TEdit;
    LblInput: TLabel;
    lblOutput: TLabel;
    ChkSubdir: TCheckBox;
    ChkDiffDir: TCheckBox;
    ChkExtPath: TCheckBox;
    BtnInputDir: TSpeedButton;
    BtnOutputDir: TSpeedButton;
    BtnUnzip: TButton;
    ChkOver: TCheckBox;
    TxtOutput: TEdit;
    LblZipInput: TLabel;
    LblZipOutput: TLabel;
    TxtZipIn: TEdit;
    TxtZipOut: TEdit;
    BtnZipIn: TSpeedButton;
    BtnZipOut: TSpeedButton;
    ChkZipSub: TCheckBox;
    GrpFilter: TGroupBox;
    ListFilter: TListBox;
    BtnFilAdd: TSpeedButton;
    BtnFilMin: TSpeedButton;
    BtnZip: TButton;
    BtnClose: TButton;
    ShtRename: TTabSheet;
    TxtRenIn: TEdit;
    LblRenIn: TLabel;
    ChkRenSub: TCheckBox;
    BtnRenIn: TSpeedButton;
    BtnRename: TButton;
    ShtVerify: TTabSheet;
    Label1: TLabel;
    TxtVerIn: TEdit;
    ChkVerSub: TCheckBox;
    BtnVerIn: TSpeedButton;
    BtnVerify: TButton;
    TxtVerOut: TEdit;
    BtnVerOut: TSpeedButton;
    lblInvalid: TLabel;
    LblTotVer: TLabel;
    ProgBar: TProgressBar;
    RadZipToFile: TRadioButton;
    RadFileToZip: TRadioButton;
    TrackComp: TTrackBar;
    lblCompression: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    jvBrowse: TJvBrowseForFolderDialog;
    procedure FormCreate(Sender: TObject);
    procedure BtnUnzipClick(Sender: TObject);
    procedure BtnInputDirClick(Sender: TObject);
    procedure BtnOutputDirClick(Sender: TObject);
    procedure BtnZipInClick(Sender: TObject);
    procedure BtnZipOutClick(Sender: TObject);
    procedure BtnFilAddClick(Sender: TObject);
    procedure BtnFilMinClick(Sender: TObject);
    procedure BtnZipClick(Sender: TObject);
    procedure BtnRenInClick(Sender: TObject);
    procedure BtnRenameClick(Sender: TObject);
    procedure BtnVerifyClick(Sender: TObject);
    procedure BtnVerInClick(Sender: TObject);
    procedure BtnVerOutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ZipRenameList: TList;
  end;

implementation

uses FindFile, shellAPI, uJFile, uJZip, fMain, JCLStrings, uJUtilities, uQPConst;

{$R *.dfm}
{$WARN SYMBOL_PLATFORM OFF}

{-----------------------------------------------------------------------------}

procedure TFrmZip.FormCreate(Sender: TObject);
begin
  PageZip.ActivePageIndex := 0;
end;

{-----------------------------------------------------------------------------}

procedure TFrmZip.BtnUnzipClick(Sender: TObject);
var
  Find : ThhFindFile;
  i : integer;
  OldStyle : TCursor;
begin

  If DirCheck(TxtInput.Text, QP_INPUT) = false then
    exit;
  if DirCheck(TxtOutput.Text, QP_OUTPUT) = false then
    exit;
  
  OldStyle := screen.Cursor;
  Screen.Cursor := crHourGlass;

  Find := ThhFindFile.Create(self);

  try

    Find.Filter := '*.zip';
    Find.Directory := IncludeTrailingPathDelimiter(TxtInput.Text);
    Find.Execute;

    ProgBar.Position := 0;
    ProgBar.Max := Find.TotalFile;
    for i := 0 to Find.TotalFile-1 do
    begin

      try
        UnzipZip(Find.Files[i], TxtOutput.Text, ChkDiffDir.Checked,
          ChkExtPath.Checked, ChkOver.Checked);
      except
        on e: EJException Do MessageDlg(E.Message, mtError, [mbOK], 0);
      end;

      ProgBar.StepIt;

    end;

  finally
    FreeAndNil(Find);
    Screen.Cursor := OldStyle;
  end;
end;

{-----------------------------------------------------------------------------}

procedure TFrmZip.BtnInputDirClick(Sender: TObject);
begin
  if jvBrowse.execute then
    if jvBrowse.Directory <> '' then
      TxtInput.text := jvBrowse.Directory;
end;

procedure TFrmZip.BtnOutputDirClick(Sender: TObject);
begin
  if jvBrowse.execute then
    if jvBrowse.Directory <> '' then
      TxtOutput.text := jvBrowse.Directory;
end;

procedure TFrmZip.BtnZipInClick(Sender: TObject);
begin
  if jvBrowse.execute then
    if jvBrowse.Directory <> '' then
      TxtZipIn.text := jvBrowse.Directory;
end;

procedure TFrmZip.BtnZipOutClick(Sender: TObject);
begin
  if jvBrowse.execute then
    if jvBrowse.Directory <> '' then
      TxtZipOut.text := jvBrowse.Directory;
end;

procedure TFrmZip.BtnFilAddClick(Sender: TObject);
begin
  Listfilter.items.Add(inputBox(QP_FOLOPTFRM_FILE_EXT,QP_FOLOPTFRM_FILE_EXT_1,''));
end;

procedure TFrmZip.BtnFilMinClick(Sender: TObject);
begin
  If ListFilter.Items.Count > 0 then
    Listfilter.Items.Delete(Listfilter.itemindex);
end;

procedure TFrmZip.BtnZipClick(Sender: TObject);
var
  Find : ThhFindFile;
  i : integer;
  OldStyle : TCursor;
  filter : String;
begin

  If DirCheck(TxtZipIn.Text, QP_INPUT) = false then
    exit;
  if DirCheck(TxtZipOut.Text, QP_OUTPUT) = false then
    exit;

  OldStyle := screen.Cursor;
  Screen.Cursor := crHourGlass;

  Find := ThhFindFile.Create(self);
  try

    If ListFilter.Items.Count = 0 then
      Find.Filter := '*.*'
    else
    begin
    
      for i := 0 to (listfilter.Items.Count - 1) do
        filter := filter + ';' + listfilter.items[i];

      Find.Filter := filter;
    end;
    
    Find.Directory := TxtZipIn.Text;
    Find.Attributes := [ffReadOnly, ffHidden];

    If ChkZipSub.Checked then
      Find.Recurse := true
    else
      Find.Recurse := false;

    Find.Execute;

    IF Find.totalFile > 0 then
    begin

      ProgBar.Position := 0;
      ProgBar.Max := Find.TotalFile;

      for i := 0 to Find.TotalFile-1 do
      begin
        try
          ZipSingleFile(Find.Files[i], TxtZipOut.Text, TrackComp.Position);
        except
          on E: EJException do MessageDlg(E.Message, mtError, [mbOK], 0);
        end;
        ProgBar.StepIt;
      end;


    end;

  finally
    FreeAndNil(Find);
    Screen.Cursor := OldStyle;
  end;
end;

procedure TFrmZip.BtnRenInClick(Sender: TObject);
begin
  if jvBrowse.execute then
    if jvBrowse.Directory <> '' then
      TxtRenIn.text := jvBrowse.Directory;
end;

procedure TFrmZip.BtnRenameClick(Sender: TObject);
Var
  Find : ThhFindFile;
  i : integer;
begin

  If DirCheck(TxtRenIn.Text, QP_INPUT) = false then
    exit;

  Find := ThhFindFile.Create(self);
  try

    Find.Directory := TxtRenIn.Text;
    Find.Attributes := [ffReadOnly, ffHidden];
    Find.Filter := '*.zip';

    If ChkRenSub.Checked then
      Find.Recurse := true
    else
      Find.Recurse := false;

    Find.Execute;
    SetCurrentDir(TxtRenIn.Text);

    ProgBar.Position := 0;
    ProgBar.Max := Find.TotalFile;

    For i := 0 to (Find.TotalFile-1) do
    begin

      try
        If RadZipToFile.Checked then
          RenameZipToContents(Find.Files[i]);

        If RadFileToZip.Checked then
          RenameContentsToZip(Find.Files[i]);
      except
        on e: EJexception do MessageDlg(E.Message, mtError, [mbOK], 0);
      end;

      ProgBar.StepIt;

    end;

  finally
    FreeAndNil(Find);
  end;
end;

procedure TFrmZip.BtnVerifyClick(Sender: TObject);
Var
  Find : ThhFindFile;
  i, BadCount : Integer;
  temp : String;
begin

  If DirCheck(TxtVerIn.Text, QP_INPUT) = false then
    exit;
  if DirCheck(TxtVerOut.Text, QP_OUTPUT) = false then
    exit;
  
  Find := ThhFindFile.Create(self);
  try

    lblInvalid.Caption := '';
    lblTotVer.Caption := '';
    Find.Recurse := ChkVerSub.Checked;
    Find.Directory := TxtVerIn.Text;
    Find.Attributes := [ffReadOnly, ffHidden];
    Find.Filter := '*.zip';
    BadCount := 0;

    Find.Execute;

    ProgBar.Position;
    ProgBar.Max := Find.TotalFile;

    for i := 0 to find.TotalFile-1 do
    begin

      // Test each zip in turn with the VerifyZip function

      if VerifyZip(Find.Files[i]) = false  then
      begin

      // If the zip file is invalid then move it to the specified directory.
        Temp := IncludeTrailingPathDelimiter(TxtVerOut.Text);
        Temp := Temp + ExtractFileName(Find.Files[i]);
        FileCopy(find.Files[i], Temp, true);
      // Now increment the BadCount variable.
        Inc(BadCount);

      end;

      ProgBar.StepIt;
    end;

    LblTotVer.Caption := IntToStr(Find.TotalFile);
    LblInvalid.Caption := IntToStr(BadCount);

  finally
    FreeAndNil(find);
  end;

end;

procedure TFrmZip.BtnVerInClick(Sender: TObject);
begin
  if jvBrowse.execute then
    if jvBrowse.Directory <> '' then
      TxtVerIn.text := jvBrowse.Directory;
end;

procedure TFrmZip.BtnVerOutClick(Sender: TObject);
begin
  if jvBrowse.execute then
    if jvBrowse.Directory <> '' then
      TxtVerOut.text := jvBrowse.Directory;
end;

end.
